
# lwc-reactjs-template

template project for creating ReactJS applications able to be hosted and interact with lightning web components in salesforce

## How to use this project 

To make your own reactjs application and run it inside of a salesforce application, clone this project and take the following steps 

 - update ```.env``` to have the PUBLIC_URL be 
 ```/lcc/*``` where you replace * with the name of your reactjs application. This will be the same as the name of the zip file you zip the build contents to. 

 - build your application for production. If you're using the default create-react-app setup, this is done by running ```npm run build```

 - zip the contents of your build folder resulting from the ```npm run build``` to a zip file named the same as the extension you put in the first step when modifying ```.env```. On macOS terminal, the zip command would be 

 ```
 $ cd <project root>/build
 $ zip -r <project-name>.zip .
 ```

 - copy the zip file you just made to the static resources within your salesforce application package. Make sure to create the appropriate resource-meta.xml file for the zip file that defines the content type as ```application/zip```

 - In your aura or lightning component, make a new tag in your .cmp file using a lightning container element. 

 - In the controller for your aura/lightning  component, make a function that handles passing and receiving messages from the reactjs application. 

 more info here https://developer.salesforce.com/blogs/2018/04/lightning-container-component-building-components-with-react-angular-and-other-libraries.html
## Available Scripts

In the project directory, you can run:

### `yarn start`

Runs the app in the development mode.<br />
Open [http://localhost:3000](http://localhost:3000) to view it in the browser.

The page will reload if you make edits.<br />
You will also see any lint errors in the console.

### `yarn test`

Launches the test runner in the interactive watch mode.<br />
See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.

### `yarn build`

Builds the app for production to the `build` folder.<br />
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.<br />
Your app is ready to be deployed!

See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.

### `yarn eject`

**Note: this is a one-way operation. Once you `eject`, you can’t go back!**

If you aren’t satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.

Instead, it will copy all the configuration files and the transitive dependencies (Webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you’re on your own.

You don’t have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn’t feel obligated to use this feature. However we understand that this tool wouldn’t be useful if you couldn’t customize it when you are ready for it.

## Learn More

You can learn more in the [Create React App documentation](https://facebook.github.io/create-react-app/docs/getting-started).

To learn React, check out the [React documentation](https://reactjs.org/).

### Code Splitting

This section has moved here: https://facebook.github.io/create-react-app/docs/code-splitting

### Analyzing the Bundle Size

This section has moved here: https://facebook.github.io/create-react-app/docs/analyzing-the-bundle-size

### Making a Progressive Web App

This section has moved here: https://facebook.github.io/create-react-app/docs/making-a-progressive-web-app

### Advanced Configuration

This section has moved here: https://facebook.github.io/create-react-app/docs/advanced-configuration

### Deployment

This section has moved here: https://facebook.github.io/create-react-app/docs/deployment

### `yarn build` fails to minify

This section has moved here: https://facebook.github.io/create-react-app/docs/troubleshooting#npm-run-build-fails-to-minify
